package jndi;

import com.bea.JNDI.examples.*;
import javax.naming.*;
import java.util.Hashtable;

public class Use {
    public static void main (String [] args){
        AddressBook adibo1 = new AddressBook("Stphane","12 alle des tilleul BADENBADEN","01010101",28);
        AddressBook adibo2 = new AddressBook("Jol","12bis alle des tilleul BADENBADEN","01010102",33);
        AddressBook adibo3 = new AddressBook("Lechef","15 alle des tilleul BADENBADEN","01010103",38);
        try {
            InitialContext initialContext = Use.getInitialContext();
            initialContext.rebind(adibo1.getName(), adibo1);
            initialContext.rebind(adibo2.getName(), adibo2);
            initialContext.rebind(adibo3.getName(), adibo3);
        }catch(Exception e){
            System.out.println(e);
        }
/*      try{
           Use.ListContext();
      }catch(Exception e){ System.out.println(e);}
*/           
    }

    public static void ListContext() {
        try {
            javax.naming.InitialContext leContext=Use.getInitialContext();
            javax.naming.NamingEnumeration lEnumeration=leContext.list("");
        
            System.out.println("Les objets du service de nommage :");
            while(lEnumeration.hasMore()){
                javax.naming.NameClassPair ncp= (javax.naming.NameClassPair)lEnumeration.next();
                System.out.println("Objet de classe : "+ncp.getClassName()+" s'appelle : "+ncp.getName());
            }
        }catch(Exception e){
            e.printStackTrace();
        }
    }

      public static InitialContext getInitialContextDesAutres()throws NamingException {
        Hashtable env = new Hashtable();
        env.put(Context.INITIAL_CONTEXT_FACTORY,
                "weblogic.jndi.WLInitialContextFactory" );
        env.put(Context.PROVIDER_URL, "t3://pascal2:7001");
        
        InitialContext Context = new InitialContext(env);
        return Context;
    }
  
    public static InitialContext getInitialContext()throws NamingException {
        Hashtable env = new Hashtable();
        env.put(Context.INITIAL_CONTEXT_FACTORY,
                "weblogic.jndi.WLInitialContextFactory" );
        env.put(Context.PROVIDER_URL, "t3://localhost:7001");
        
        InitialContext Context = new InitialContext(env);
        return Context;
    }
}
