package exos.transcript; 

import exos.transcript.TranscriptHome;
import exos.transcript.Transcript;
import exos.transcript.TranscriptPK;
import javax.ejb.FinderException;

class LeCoursSuivi {
    public static void main (String args[]){
        try {
            javax.naming.Context context = exos.Use.getInitialContext();
            TranscriptHome lUsineACours = (TranscriptHome)context.lookup("transcript.TranscriptEJB");
            
            java.util.Vector lesCours=new java.util.Vector();
            
            //Recherche des instances au niveau du client
            for (int i=0; i<3; i++){
                // Recherche d'une instance dans la base
                Transcript lInstance;
                TranscriptPK laCle=new TranscriptPK(i);
                try{
                    lInstance=lUsineACours.findByPrimaryKey(laCle);
                    lesCours.insertElementAt(lInstance, i);
                }catch(FinderException e){
                    // Si l'instance n'existe pas on cre une instance de base
                    String a="TIP_"+i;
                    String b="Informatique_"+i;
                    String c="A_"+i;
                    lInstance=lUsineACours.create(a, b, c, 12.3d, "INSA", i);
                    lesCours.addElement(lInstance);
                }
            }
            // Liste des rfrences
            try{
                int i=0;
                Transcript leC;
                while (true){
                    leC=(Transcript)lesCours.elementAt(i);
                    System.out.println("Le cours s'appelle "+ leC.getName());
                    i++;
                }
            }catch(ArrayIndexOutOfBoundsException e){}
            
            // On supprime un lment du vector
            Transcript aSupprimer=(Transcript)lesCours.elementAt(1);
            lesCours.removeElementAt(1);
            aSupprimer.remove();
            // On les supprimes
            for (int i=0; i<lesCours.size(); i++){
                try{
                   System.out.println("Le cours s'appelle" + ((Transcript)lesCours.elementAt(i)).getName());
                }catch(Exception e){
                    System.out.println("Erreur l'objet n'existe plus"+e);
                }
            }
            
            //Ou bien on accde  l'usine
            Transcript aSupprimer2=(Transcript)lesCours.elementAt(1);
            lesCours.removeElementAt(1);
//aSupprimer.remove();           

           /* OK Ca fonctionne */
            javax.ejb.Handle uneReferenceEJB=aSupprimer2.getHandle();
            lUsineACours.remove(uneReferenceEJB);

/* KO Exception
            javax.ejb.EJBObject uneReferenceEJB2=aSupprimer2.getHandle().getEJBObject();
            lUsineACours.remove(uneReferenceEJB2);            
*/            

            for (int i=0; i<lesCours.size(); i++){
                try{
                   System.out.println("Le cours s'appelle" + ((Transcript)lesCours.elementAt(i)).getName());
                }catch(Exception e){
                    System.out.println("Erreur l'objet n'existe plus");
                }
            }
            
        }catch(Exception e){
            System.out.println(e);
        }
    }
}            
