package com.bea.EJBD.examples;

import java.rmi.*;
import javax.ejb.*;
/**
 * This type was created in VisualAge.
 */
public class FibonacciComputationBean implements SessionBean {
public FibonacciComputationBean() {
	System.out.println("FibonacciComputationBean()--");
}
public void ejbActivate() {
	System.out.println("ejbActivate()");
}
public void ejbCreate() {
	System.out.println("This EJB has been created");
}
public void ejbPassivate() {
		System.out.println("ejbPassivate()");
}
public void ejbRemove() {
	System.out.println("ejbRemove()");
}
public int getFibonacciNumber(int n) {
	//
	// Notice that this method does not have to throw
	// any exceptions even though they are declared
	// as such in the remote interface.  This is
	// because the session EJB is not the remote object.
	// Always remember that the client only deals with
	// EJBObjects, not the EJBs.
	//
	// Calculate the nth Fibonacci number
	if (n <= 0)
		return 0;

	//
	// This is the F[1] condition:
	if (n == 1)
		return 1;

	int prev2 = 0;
	int prev1 = 1;
	int fib = 0;
	
	for (int i=2; i<=n; i++) {
		fib = prev1 + prev2;

		//
		// Now adjust the previous values.
		prev2 = prev1;
		prev1 = fib;
	}

	return fib;
}
public void setSessionContext(SessionContext arg1) {
	System.out.println("setSessionContext()");
}
}