package com.bea.EJBD.examples;

 import java.util.*;
 import javax.naming.*;
 import javax.ejb.*;
 import java.rmi.*;
 import com.bea.JNDI.examples.*;
 
public class FibonacciComputationClient {
/**
 * This method was created in VisualAge.
 * @param args java.lang.String[]
 */
public static void main(String args[]) {

	try {

		InitialContext initialContext = JNDIConfiguration.getInitialContext();
		
		//
		// Do a lookup on the name that we configured during
		// deployment.  You need to indentify where the JNDI
		// name for your particular vendor is configured.
		//
		// The lookup method for EJB JNDI providers always returns
		// the home interface.
		FibonacciComputationHome home =
		    (FibonacciComputationHome) initialContext.lookup("FibonacciComputationEJB");

		//
		// Calling the create() method on the home interface generates
		// an EJBObject that gets returned to us.  The data type
		// of that object matches the remote interface for the EJB.
		FibonacciComputation theFib = (FibonacciComputation)home.create();

		//
		// Now that we have the EJB, let's calculate the first 20
		// fibonacci numbers.
		for (int i=0; i<20; i++) {
			System.out.print("Fib[" + i + "] = ");
			System.out.println(theFib.getFibonacciNumber(i));
		}
	} catch(Exception e) {
		System.out.println(e);
	}
}
}