package ibazard;

public class GestEncheresBean implements javax.ejb.SessionBean {

    //Interface SessionBean
    private javax.ejb.SessionContext context;
    public void ejbActivate(){}
    public void ejbPassivate(){}
    public void ejbRemove(){}
    public void setSessionContext(javax.ejb.SessionContext toto){this.context=toto;}  

    //Interface Home
    public void ejbCreate(ibazard.UnObjet lObjet, String leProprio, int leNombreMaxdEncheres) throws javax.ejb.CreateException {
            this.proprietaire=leProprio;
            this.nombreDEncheresMax=leNombreMaxdEncheres;
            this.lObjetAuxEncheres=lObjet;
    }

    //Interface du Bean
    public void addBid(UneEnchere lEnchere) throws NotEnoughException, ExceedMaxEnchereException {
        if (lEnchere.getMontant()<lastValueOfBid){
            throw new NotEnoughException("Pas assez cher !!! la derniere enchere est de : "+lastValueOfBid);
        }
        if (lesEncheres.size()== nombreDEncheresMax){
            throw new ExceedMaxEnchereException("Les encheres sont closes le nombre max est de : "+nombreDEncheresMax);
        }
        lesEncheres.addElement(lEnchere);
        lastValueOfBid=lEnchere.getMontant();
    }       
    public UneEnchere getLastBid() {return (UneEnchere)lesEncheres.lastElement();}
    public int getMaxBids(){return this.nombreDEncheresMax;}
    public UnObjet getObject(){return this.lObjetAuxEncheres;}
    public String getObjectOwner(){return this.proprietaire;} 

    //Attributs internes du Bean
    java.util.Vector lesEncheres=new java.util.Vector();
    double lastValueOfBid=0;
    String proprietaire;
    int nombreDEncheresMax;
    UnObjet lObjetAuxEncheres;
}
